// Code generated by protoc-gen-go. DO NOT EDIT.
// source: types.proto

/*
Package types is a generated protocol buffer package.

It is generated from these files:
	types.proto

It has these top-level messages:
	CreateSessionRequest
	SessionUpdated
	HealthCheckRequest
	HealthCheckResponse
*/
package types

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import events "github.com/vx-labs/iot-mqtt-events"
import packet "github.com/vx-labs/mqtt-protocol/packet"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type HealthCheckResponse_ServingStatus int32

const (
	HealthCheckResponse_UNKNOWN     HealthCheckResponse_ServingStatus = 0
	HealthCheckResponse_SERVING     HealthCheckResponse_ServingStatus = 1
	HealthCheckResponse_NOT_SERVING HealthCheckResponse_ServingStatus = 2
)

var HealthCheckResponse_ServingStatus_name = map[int32]string{
	0: "UNKNOWN",
	1: "SERVING",
	2: "NOT_SERVING",
}
var HealthCheckResponse_ServingStatus_value = map[string]int32{
	"UNKNOWN":     0,
	"SERVING":     1,
	"NOT_SERVING": 2,
}

func (x HealthCheckResponse_ServingStatus) String() string {
	return proto.EnumName(HealthCheckResponse_ServingStatus_name, int32(x))
}
func (HealthCheckResponse_ServingStatus) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor0, []int{3, 0}
}

type CreateSessionRequest struct {
	Id           string          `protobuf:"bytes,1,opt,name=id" json:"id,omitempty"`
	Tenant       string          `protobuf:"bytes,2,opt,name=tenant" json:"tenant,omitempty"`
	ConnectInfos *packet.Connect `protobuf:"bytes,3,opt,name=connectInfos" json:"connectInfos,omitempty"`
}

func (m *CreateSessionRequest) Reset()                    { *m = CreateSessionRequest{} }
func (m *CreateSessionRequest) String() string            { return proto.CompactTextString(m) }
func (*CreateSessionRequest) ProtoMessage()               {}
func (*CreateSessionRequest) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

func (m *CreateSessionRequest) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *CreateSessionRequest) GetTenant() string {
	if m != nil {
		return m.Tenant
	}
	return ""
}

func (m *CreateSessionRequest) GetConnectInfos() *packet.Connect {
	if m != nil {
		return m.ConnectInfos
	}
	return nil
}

type SessionUpdated struct {
}

func (m *SessionUpdated) Reset()                    { *m = SessionUpdated{} }
func (m *SessionUpdated) String() string            { return proto.CompactTextString(m) }
func (*SessionUpdated) ProtoMessage()               {}
func (*SessionUpdated) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

type HealthCheckRequest struct {
	Service string `protobuf:"bytes,1,opt,name=service" json:"service,omitempty"`
}

func (m *HealthCheckRequest) Reset()                    { *m = HealthCheckRequest{} }
func (m *HealthCheckRequest) String() string            { return proto.CompactTextString(m) }
func (*HealthCheckRequest) ProtoMessage()               {}
func (*HealthCheckRequest) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func (m *HealthCheckRequest) GetService() string {
	if m != nil {
		return m.Service
	}
	return ""
}

type HealthCheckResponse struct {
	Status HealthCheckResponse_ServingStatus `protobuf:"varint,1,opt,name=status,enum=HealthCheckResponse_ServingStatus" json:"status,omitempty"`
}

func (m *HealthCheckResponse) Reset()                    { *m = HealthCheckResponse{} }
func (m *HealthCheckResponse) String() string            { return proto.CompactTextString(m) }
func (*HealthCheckResponse) ProtoMessage()               {}
func (*HealthCheckResponse) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{3} }

func (m *HealthCheckResponse) GetStatus() HealthCheckResponse_ServingStatus {
	if m != nil {
		return m.Status
	}
	return HealthCheckResponse_UNKNOWN
}

func init() {
	proto.RegisterType((*CreateSessionRequest)(nil), "CreateSessionRequest")
	proto.RegisterType((*SessionUpdated)(nil), "SessionUpdated")
	proto.RegisterType((*HealthCheckRequest)(nil), "HealthCheckRequest")
	proto.RegisterType((*HealthCheckResponse)(nil), "HealthCheckResponse")
	proto.RegisterEnum("HealthCheckResponse_ServingStatus", HealthCheckResponse_ServingStatus_name, HealthCheckResponse_ServingStatus_value)
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for SessionsService service

type SessionsServiceClient interface {
	New(ctx context.Context, in *CreateSessionRequest, opts ...grpc.CallOption) (*SessionUpdated, error)
	Get(ctx context.Context, in *events.SessionSelector, opts ...grpc.CallOption) (*events.Session, error)
	List(ctx context.Context, in *events.SessionSelector, opts ...grpc.CallOption) (SessionsService_ListClient, error)
	Delete(ctx context.Context, in *events.SessionSelector, opts ...grpc.CallOption) (*SessionUpdated, error)
	SetOffline(ctx context.Context, in *events.SessionSelector, opts ...grpc.CallOption) (*SessionUpdated, error)
	UpdateTTL(ctx context.Context, in *events.SessionSelector, opts ...grpc.CallOption) (*SessionUpdated, error)
	Check(ctx context.Context, in *HealthCheckRequest, opts ...grpc.CallOption) (*HealthCheckResponse, error)
}

type sessionsServiceClient struct {
	cc *grpc.ClientConn
}

func NewSessionsServiceClient(cc *grpc.ClientConn) SessionsServiceClient {
	return &sessionsServiceClient{cc}
}

func (c *sessionsServiceClient) New(ctx context.Context, in *CreateSessionRequest, opts ...grpc.CallOption) (*SessionUpdated, error) {
	out := new(SessionUpdated)
	err := grpc.Invoke(ctx, "/SessionsService/New", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sessionsServiceClient) Get(ctx context.Context, in *events.SessionSelector, opts ...grpc.CallOption) (*events.Session, error) {
	out := new(events.Session)
	err := grpc.Invoke(ctx, "/SessionsService/Get", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sessionsServiceClient) List(ctx context.Context, in *events.SessionSelector, opts ...grpc.CallOption) (SessionsService_ListClient, error) {
	stream, err := grpc.NewClientStream(ctx, &_SessionsService_serviceDesc.Streams[0], c.cc, "/SessionsService/List", opts...)
	if err != nil {
		return nil, err
	}
	x := &sessionsServiceListClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type SessionsService_ListClient interface {
	Recv() (*events.Session, error)
	grpc.ClientStream
}

type sessionsServiceListClient struct {
	grpc.ClientStream
}

func (x *sessionsServiceListClient) Recv() (*events.Session, error) {
	m := new(events.Session)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *sessionsServiceClient) Delete(ctx context.Context, in *events.SessionSelector, opts ...grpc.CallOption) (*SessionUpdated, error) {
	out := new(SessionUpdated)
	err := grpc.Invoke(ctx, "/SessionsService/Delete", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sessionsServiceClient) SetOffline(ctx context.Context, in *events.SessionSelector, opts ...grpc.CallOption) (*SessionUpdated, error) {
	out := new(SessionUpdated)
	err := grpc.Invoke(ctx, "/SessionsService/SetOffline", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sessionsServiceClient) UpdateTTL(ctx context.Context, in *events.SessionSelector, opts ...grpc.CallOption) (*SessionUpdated, error) {
	out := new(SessionUpdated)
	err := grpc.Invoke(ctx, "/SessionsService/UpdateTTL", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sessionsServiceClient) Check(ctx context.Context, in *HealthCheckRequest, opts ...grpc.CallOption) (*HealthCheckResponse, error) {
	out := new(HealthCheckResponse)
	err := grpc.Invoke(ctx, "/SessionsService/Check", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for SessionsService service

type SessionsServiceServer interface {
	New(context.Context, *CreateSessionRequest) (*SessionUpdated, error)
	Get(context.Context, *events.SessionSelector) (*events.Session, error)
	List(*events.SessionSelector, SessionsService_ListServer) error
	Delete(context.Context, *events.SessionSelector) (*SessionUpdated, error)
	SetOffline(context.Context, *events.SessionSelector) (*SessionUpdated, error)
	UpdateTTL(context.Context, *events.SessionSelector) (*SessionUpdated, error)
	Check(context.Context, *HealthCheckRequest) (*HealthCheckResponse, error)
}

func RegisterSessionsServiceServer(s *grpc.Server, srv SessionsServiceServer) {
	s.RegisterService(&_SessionsService_serviceDesc, srv)
}

func _SessionsService_New_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateSessionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SessionsServiceServer).New(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/SessionsService/New",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SessionsServiceServer).New(ctx, req.(*CreateSessionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _SessionsService_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SessionSelector)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SessionsServiceServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/SessionsService/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SessionsServiceServer).Get(ctx, req.(*events.SessionSelector))
	}
	return interceptor(ctx, in, info, handler)
}

func _SessionsService_List_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(events.SessionSelector)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(SessionsServiceServer).List(m, &sessionsServiceListServer{stream})
}

type SessionsService_ListServer interface {
	Send(*events.Session) error
	grpc.ServerStream
}

type sessionsServiceListServer struct {
	grpc.ServerStream
}

func (x *sessionsServiceListServer) Send(m *events.Session) error {
	return x.ServerStream.SendMsg(m)
}

func _SessionsService_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SessionSelector)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SessionsServiceServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/SessionsService/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SessionsServiceServer).Delete(ctx, req.(*events.SessionSelector))
	}
	return interceptor(ctx, in, info, handler)
}

func _SessionsService_SetOffline_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SessionSelector)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SessionsServiceServer).SetOffline(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/SessionsService/SetOffline",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SessionsServiceServer).SetOffline(ctx, req.(*events.SessionSelector))
	}
	return interceptor(ctx, in, info, handler)
}

func _SessionsService_UpdateTTL_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SessionSelector)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SessionsServiceServer).UpdateTTL(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/SessionsService/UpdateTTL",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SessionsServiceServer).UpdateTTL(ctx, req.(*events.SessionSelector))
	}
	return interceptor(ctx, in, info, handler)
}

func _SessionsService_Check_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(HealthCheckRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SessionsServiceServer).Check(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/SessionsService/Check",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SessionsServiceServer).Check(ctx, req.(*HealthCheckRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _SessionsService_serviceDesc = grpc.ServiceDesc{
	ServiceName: "SessionsService",
	HandlerType: (*SessionsServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "New",
			Handler:    _SessionsService_New_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _SessionsService_Get_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _SessionsService_Delete_Handler,
		},
		{
			MethodName: "SetOffline",
			Handler:    _SessionsService_SetOffline_Handler,
		},
		{
			MethodName: "UpdateTTL",
			Handler:    _SessionsService_UpdateTTL_Handler,
		},
		{
			MethodName: "Check",
			Handler:    _SessionsService_Check_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "List",
			Handler:       _SessionsService_List_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "types.proto",
}

func init() { proto.RegisterFile("types.proto", fileDescriptor0) }

var fileDescriptor0 = []byte{
	// 412 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x94, 0x92, 0x41, 0x6f, 0xd3, 0x40,
	0x10, 0x85, 0xb1, 0x03, 0xa9, 0x3a, 0x81, 0x38, 0xda, 0x16, 0x88, 0x72, 0xaa, 0x7c, 0xea, 0xc5,
	0xeb, 0xca, 0x15, 0x1c, 0x7a, 0x0d, 0xa8, 0x54, 0x54, 0x8e, 0x64, 0xa7, 0x70, 0x44, 0xf6, 0x7a,
	0xd2, 0xac, 0xea, 0xee, 0xba, 0xde, 0x49, 0x80, 0x1f, 0xc1, 0x3f, 0xe6, 0x80, 0x6a, 0x6f, 0x0e,
	0x2e, 0x56, 0xa5, 0x9c, 0xec, 0xd9, 0xf7, 0x3e, 0xef, 0xf3, 0xcc, 0xc0, 0x88, 0x7e, 0x57, 0x68,
	0x78, 0x55, 0x6b, 0xd2, 0xb3, 0xf0, 0x56, 0xd2, 0x7a, 0x93, 0x73, 0xa1, 0xef, 0xc3, 0xed, 0xaf,
	0xa0, 0xcc, 0x72, 0x13, 0x4a, 0x4d, 0xc1, 0xfd, 0x03, 0x51, 0x80, 0x5b, 0x54, 0x64, 0xc2, 0xf6,
	0x61, 0x81, 0xb3, 0x1e, 0xa0, 0x31, 0x37, 0xb2, 0xd0, 0x65, 0x58, 0x65, 0xe2, 0x0e, 0x29, 0xac,
	0xf2, 0x96, 0xf0, 0x0d, 0x1c, 0xcf, 0x6b, 0xcc, 0x08, 0x53, 0x34, 0x46, 0x6a, 0x95, 0xe0, 0xc3,
	0x06, 0x0d, 0xb1, 0x31, 0xb8, 0xb2, 0x98, 0x3a, 0x27, 0xce, 0xe9, 0x61, 0xe2, 0xca, 0x82, 0xbd,
	0x83, 0x21, 0xa1, 0xca, 0x14, 0x4d, 0xdd, 0xe6, 0xcc, 0x56, 0xec, 0x1c, 0x5e, 0x0b, 0xad, 0x14,
	0x0a, 0xba, 0x52, 0x2b, 0x6d, 0xa6, 0x83, 0x13, 0xe7, 0x74, 0x14, 0x79, 0xbc, 0xbd, 0x87, 0xcf,
	0x5b, 0x2d, 0xe9, 0x98, 0xfc, 0x09, 0x8c, 0xed, 0x75, 0x37, 0x55, 0x91, 0x11, 0x16, 0x3e, 0x07,
	0xf6, 0x05, 0xb3, 0x92, 0xd6, 0xf3, 0x35, 0x8a, 0xbb, 0x5d, 0x88, 0x29, 0x1c, 0x18, 0xac, 0xb7,
	0x52, 0xa0, 0x4d, 0xb2, 0x2b, 0xfd, 0x3f, 0x0e, 0x1c, 0x75, 0x00, 0x53, 0x69, 0x65, 0x90, 0x5d,
	0xc0, 0xd0, 0x50, 0x46, 0x1b, 0xd3, 0x00, 0xe3, 0xc8, 0xe7, 0x3d, 0x2e, 0x9e, 0x3e, 0x7e, 0x45,
	0xdd, 0xa6, 0x8d, 0x33, 0xb1, 0x84, 0x7f, 0x01, 0x6f, 0x3a, 0x02, 0x1b, 0xc1, 0xc1, 0x4d, 0xfc,
	0x35, 0x5e, 0x7c, 0x8f, 0x27, 0x2f, 0x1e, 0x8b, 0xf4, 0x73, 0xf2, 0xed, 0x2a, 0xbe, 0x9c, 0x38,
	0xcc, 0x83, 0x51, 0xbc, 0x58, 0xfe, 0xd8, 0x1d, 0xb8, 0xd1, 0x5f, 0x17, 0x3c, 0xfb, 0x4b, 0x26,
	0x6d, 0x33, 0xb2, 0x00, 0x06, 0x31, 0xfe, 0x64, 0x6f, 0x79, 0x5f, 0x83, 0x67, 0x1e, 0xef, 0xb6,
	0x80, 0x85, 0x30, 0xb8, 0x44, 0x62, 0xef, 0xb9, 0x9d, 0xa8, 0x95, 0x53, 0x2c, 0x51, 0x90, 0xae,
	0x67, 0xde, 0x13, 0x81, 0x45, 0xf0, 0xf2, 0x5a, 0x9a, 0x3d, 0x88, 0x33, 0x87, 0x45, 0x30, 0xfc,
	0x84, 0x25, 0x12, 0x3e, 0x47, 0x3d, 0x09, 0xf6, 0x11, 0x20, 0x45, 0x5a, 0xac, 0x56, 0xa5, 0x54,
	0xfb, 0x70, 0x1f, 0xe0, 0xb0, 0x7d, 0x5d, 0x2e, 0xaf, 0xf7, 0xc0, 0x22, 0x78, 0xd5, 0x4c, 0x8b,
	0x1d, 0xf1, 0xff, 0x57, 0x62, 0x76, 0xdc, 0x37, 0xd0, 0x7c, 0xd8, 0x2c, 0xf3, 0xf9, 0xbf, 0x00,
	0x00, 0x00, 0xff, 0xff, 0xb6, 0x3f, 0x4b, 0xe0, 0x3e, 0x03, 0x00, 0x00,
}
